// constants.h
// most of the important constants
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* '
// (so that I can find it) and send the code
// to cye-code@AndreasKrueger.de
//
// last change: 3.6.2002
//          by: AK

#ifndef CONSTANTS_H
#define CONSTANTS_H

#ifndef SERVERPROGRAM
#include "classes.h"
#endif // SERVERPROGRAM

// #define NO_DEBUG   // so that the qDebug("..."); will NOT be printed
           // doesn't work for g++ SHIT! Warning compiling:
           // 'NO_DEBUG' redefined ... *Initialization*:1
           // but no effect at all,
           // still qDebug -results are printed :-(

const bool debugging=false; // some more windows appear and the client is more complicated
#include <qglobal.h>
#include <qstring.h>
const Q_UINT32 PROGRAMVERSION=107;// overall programversion
const Q_UINT32 CLIENTVERSION=106;  // the server suggests this version to the client
const Q_UINT32 MAXVERSION=199;	  // later versions will not be tolerated
								  // careful: This limits the CLIENT!
const Q_UINT32 MINVERSION=105;	  // earlier versions will not be tolerated
const QString SCVERSION="v3.31";   // ServerClient (standalone) version

const char SERVERNAME[]		="129.70.124.57";
const Q_UINT16 SERVERPORT	=4554;
const char FTPSERVERNAME[]	="ftp.AndreasKrueger.de";

const uint NumCountries=15;
const uint NumCoins=8;

const QString coinnames[NumCoins]={"1c","2c","5c","10c","20c","50c","1e","2e"};
const double coinvalues[NumCoins]={0.01,0.02,0.05,0.10,0.20,0.50,1,2};
const unsigned char coincolorInner[NumCoins][3]={{239, 181, 148},{239, 181, 148},{239, 181, 148},
{231, 206, 148},{231, 206, 148},{231, 206, 148},{214, 214, 214}, {231, 206, 148}};
const unsigned char coincolorOuter[NumCoins][3]={{239, 181, 148},{239, 181, 148},{239, 181, 148},
{231, 206, 148},{231, 206, 148},{231, 206, 148},{231, 206, 148}, {214, 214, 214}};
const unsigned char coinSizeInner[NumCoins]={106, 122, 138, 130, 145, 158, 105, 118};
const unsigned char coinSizeOuter[NumCoins]={106, 122, 138, 130, 145, 158, 150, 167};

const QString countrynames[NumCountries+1]={"com","_at","_bel","_fin","_fra",
                                            "_ger","_gre","_ire","_ita","_lux","_mon",
											"_nl","_por","_sam","_es","_vat"};
const QString countrynamesWords[NumCountries+1]={"Common Side","Austria","Belgium",
                                                 "Finland","France","Germany","Greece","Ireland",
												 "Italy","Luxemburg","Monaco", "Netherlands",
												 "Portugal", "San Marino", "Spain", "Vatican"};
const QString PICFILESUFFIX="gif";
const QString PICFILEPATH="pics/";


const uint numIDtexts=32;
const QString IDtexts[numIDtexts]={"Start", "TimerStarted", "TimerRestart",
"NextCoin", "PreviousCoin", "NextCountry", "PreviousCountry",
"CoinPictureClicked","CountryPictureClicked", "Insert", "TakeAway", "Reset",
"SaveQuit", "DontQuitAndLooseDataButReturn", "Upload",
"About", "AboutDialogClosed", "SeeDataAnalysis", "SeeDataAnalysisClosed",
"BrowseHomepage", "BrowseDownload", "BrowseResults", "BrowseWhynot",
"Settings", "SettingsDialogClosed",
"ObservationAllowedAgain", "ObservationNotAllowedAnymore",
"Quit", "WriteErrorDialogReturn", "WriteErrorDialogDiscard",
"ProgramTerminated", "ProgramTerminatedBySysbarOrAltF4"};

const uint numSettingsIDtexts=48;
const QString SettingsIDtexts[numSettingsIDtexts]={
"SettingsTabChangedTo0", "SettingsTabChangedTo1", "SettingsTabChangedTo2","SettingsTabChangedTo3",
"SettingsCountryChanged", "SettingsPostalCodeChanged", "SettingsPopulationChanged",
"SettingsParagraph1Toggled", "SettingsParagraph2Toggled",
"SettingsRecommenderMembernumberChanged", "SettingsMembernumberNonNumberFormat",
"SettingsRecommenderMembernumberSeveral",
"SettingsRecommenderMembernumberSeveralAdd","SettingsRecommenderMembernumberSeveralAddWrong",
"SettingsRecommenderMembernumberSeveralDel","SettingsRecommenderMembernumberSeveralDelWrong",
"SettingsRecommenderMembernumberSeveralEnd",
"SettingsRecommenderNameChanged",
"SettingsServiceSwitchToggled", "SettingsEMailChanged",
"SettingsWantsReminderEmailToggled", "SettingsWeeklyON", "SettingsBiMonthlyON", "SettingsMonthlyON",
"SettingsWantsRegularInformationsToggled", "SettingsWantsToHelpToggled",
"SettingsWantsToAnalyzeToggled",
"SettingsOpinionSwitchToggled",
"SettingsMixdateYearChanged", "SettingsMixdateMonthChanged",
"SettingsArrivaldateYearChanged", "SettingsArrivaldateMonthChanged",
"SettingsMessageChanged", "SettingsOldSettingsButtonPressed", "SettingsSaveButtonPressed",
"SettingsSaved", "SettingsWriteErrorDialogReturn","SettingsWriteErrorDialogDiscard",
"SettingsCountryMissing", "SettingsPostalCodeMissing", "SettingsPopulationMissing",
"SettingsParagraph1NotChecked", "SettingsParagraph2NotChecked",
"SettingsWantToInputMissingData", "SettingsDontWantToInputMissingData",
"SettingsMissingDataPersuadedContinue", "SettingsMissingDataNotPersuadedQuit",
"SettingsEndedWithUserWantsProgramTermination"};

const uint numClientIDtexts=24;
const QString ClientIDtexts[numClientIDtexts]={
"ClientStarted", "ClientWindowClosedProperlyAfterUpload", "ClientWindowAborted",
"ClientOpenConnection", "ClientServerDNSFound", "ClientServerConnected",
"ClientSendToServer", "ClientReceivingAnswer", "ClientCloseConnection",
"ClientConnectionClosedProperly", "ClientUploadSuccessful", "ClientUploadQuitWithoutUpload",
"ClientServerDNSFound", "ClientSomeSocketError", "ClientProblemExplained",
"ClientServerNotFound", "ClientHadToCloseTheConnectionImproperly",
"ClientServerAnswerBroken", "ClientServerBadDataFormat",
"ClientServerDoesntRecognizeMember", "ClientConnectionClosedByServer",
"ClientBadDatastreamTryAgain", "ClientBadDatastreamQuit", "ClientClearView"};

const uint numInvitationIDtexts=13;
const QString InvitationIDtexts[numInvitationIDtexts]={
"Invitations", "InvitationPersonInserted", "InvitationRemovedPerson","InvitationNoValidEmailAddress", 
"InvitationDidNotRemovePersonCauseNoneSelected", "InvitationDidNotRemovePersonCauseAlreadyUploaded",
"InvitationPreviousCoin", "InvitationNextCoin", "InvitationPreviousCountry", "InvitationNextCountry",
"InvitationCoinPictureClicked", "InvitationCountryPictureClicked", "InvitationsClosed"};

const uint numTableIDtexts=3;
const QString TableIDtexts[numTableIDtexts]={"CellClicked", "CellEdited", "CellFocussed"};

#define FILENAME "cyedata.cye"
#define ARCHIVEFILENAME "cyearchive.cye"
#define MAGICNUMBER    0x80a3a524
#define NO_MAGICNUMBER 0x00000000
#define CLIENT_TIMEOUT 15000

#define CYE_BAD_FILE_FORMAT 1
#define CYE_BAD_FILE_TOO_OLD 2
#define CYE_BAD_FILE_TOO_NEW 3
#define CYE_FILE_NOT_EXIST 4
#define CYE_FILE_CLOSING_ERROR 5
#define CYE_SERIALIZING_ERROR 6
#define CYE_DESERIALIZING_ERROR 7
#define CYE_TESTING_ERROR 8
#define CYE_IMPLEMENTATION_CHAOS 9
#define CYE_FILE_CORRUPT_FORMAT_SUM_DIFFERS 10

#define TCP_CLIENT_HAS_BAD_DATA_FORMAT 11
#define TCP_SERVER_EXIT 12
#define TCP_SERVER_HAS_BAD_DATA_FORMAT 13
#define TCP_SERVER_TIMEOUT 14
#define TCP_CLIENT_HAS_TOO_OLD_VERSION 15
#define TCP_CLIENT_SENDS_TOO_MUCH_DATA 16
#define CYE_CANNOT_SAVE_DATAFILE 17
#define CYE_FILE_WRITE_OPENING_ERROR 18
#define CYE_SERVER_FILE_WRITE_OPENING_ERROR 19
#define CYE_SERVER_FILE_CLOSING_ERROR 20
#define CYE_SERVER_FILE_NOT_EXIST 21
#define CYE_BAD_SERVER_FILE_FORMAT 22
#define CYE_BAD_SERVER_FILE_TOO_OLD 23
#define CYE_BAD_SERVER_FILE_TOO_NEW 24
#define USER_DOESNT_WANT_TO_INPUT_NECESSARY_DATA 25
#define TCP_CLIENT_HAS_TOO_NEW_VERSION 26
#define TCP_SERVER_DIDNT_LIKE_CLIENT_MEMBERNUMBER 27
#define TCP_NO_CONNECTION_WITH_SERVER 28
#define CYE_USER_DISCARDS_COUNTTABLE_AND_QUITS 29
#define CYE_USER_KILLS_PROGRAM_WITH_X 30
#define CYE_UPLOAD_SUCCESSFUL 31

#define TCP_NET_STREAM_ERROR 32
#define TCP_SERVER_RECEIVES_BAD_FORMAT 33
#define TCP_SERVER_IS_ILL 34

#define TCP_SERVER_ANSWER_TOO_OLD_FORMAT 35
#define TCP_SERVER_ANSWER_TOO_NEW_FORMAT 36

#define DB_CANNOT_CONNECT_TO_MYSQL_SERVER 37
#define DB_CANT_SELECT_DB 38
#define DB_RESULT_OTHER_THAN_ONE_ROW 39
#define DB_RESULT_OTHER_THAN_EXPECTED_COLUMNS 40
#define DB_COULDNT_EXECUTE_QUERY 41
#define DB_CONVERSION_YET_UNDEFINED 42
#define DB_CONVERSION_OVERFLOW 43
#define DB_RESULT_WHERE_THERE_SHOULDNT_BE 44
#define DB_INSERT_AFFECTED_LESS_OR_MORE_THAN_EXPECTED_ROWS 45
#define DB_MEMBER_DOES_NOT_EXIST 46

const int numErrorMsgs=46;
const QString errormessage[numErrorMsgs+1] = {"",
"CYE_BAD_FILE_FORMAT","CYE_BAD_FILE_TOO_OLD",
"CYE_BAD_FILE_TOO_NEW", "CYE_FILE_NOT_EXIST", "CYE_FILE_CLOSING_ERROR",
"CYE_SERIALIZING_ERROR", "CYE_DESERIALIZING_ERROR", "CYE_TESTING_ERROR",
"CYE_IMPLEMENTATION_CHAOS", "CYE_FILE_CORRUPT_FORMAT_SUM_DIFFERS",
"TCP_CLIENT_HAS_BAD_DATA_FORMAT", "TCP_SERVER_EXIT",
"TCP_SERVER_HAS_BAD_DATA_FORMAT", "TCP_SERVER_TIMEOUT",
"TCP_CLIENT_HAS_TOO_OLD_VERSION", "TCP_CLIENT_SENDS_TOO_MUCH_DATA",
"CYE_CANNOT_SAVE_DATAFILE", "CYE_FILE_WRITE_OPENING_ERROR",
"CYE_SERVER_FILE_WRITE_OPENING_ERROR", "CYE_SERVER_FILE_CLOSING_ERROR",
"CYE_SERVER_FILE_NOT_EXIST", "CYE_BAD_SERVER_FILE_FORMAT",
"CYE_BAD_SERVER_FILE_TOO_OLD", "CYE_BAD_SERVER_FILE_TOO_NEW",
"USER_DOESNT_WANT_TO_INPUT_NECESSARY_DATA","TCP_CLIENT_HAS_TOO_NEW_VERSION",
"TCP_SERVER_DIDNT_LIKE_CLIENT_MEMBERNUMBER", "TCP_NO_CONNECTION_WITH_SERVER",
"CYE_USER_DISCARDS_COUNTTABLE_AND_QUITS", "CYE_USER_KILLS_PROGRAM_WITH_X",
"CYE_UPLOAD_SUCCESSFUL", "TCP_NET_STREAM_ERROR", "TCP_SERVER_RECEIVES_BAD_FORMAT",
"TCP_SERVER_IS_ILL",
"TCP_SERVER_ANSWER_TOO_OLD_FORMAT", "TCP_SERVER_ANSWER_TOO_NEW_FORMAT",
"DB_CANNOT_CONNECT_TO_MYSQL_SERVER", "DB_CANT_SELECT_DB", 
"DB_RESULT_OTHER_THAN_ONE_ROW", "DB_RESULT_OTHER_THAN_EXPECTED_COLUMNS",
"DB_COULDNT_EXECUTE_QUERY", "DB_CONVERSION_YET_UNDEFINED", "DB_CONVERSION_OVERFLOW",
"DB_RESULT_WHERE_THERE_SHOULDNT_BE", "DB_INSERT_AFFECTED_LESS_OR_MORE_THAN_EXPECTED_ROWS",
"DB_MEMBER_DOES_NOT_EXIST" };

const QString errorhelp[numErrorMsgs+1]={"", "Delete your datafile and restart CYE.",
"Delete your datafile and restart CYE.",
"Use newer programversion! http://www.AndreasKrueger.de/euro/download",
"No problem. We just start from scratch.", "", "", "", "", "",
"The checksum of the data file/stream is incorrect! Can have many reasons - all fatal!",
"Download a newer programversion http://www.AndreasKrueger.de/euro/download",
"Perhaps try again later.",
"Doesn't seem to be a CYE server on the other side. Misuse? Please tell the author!",
"Try later when the net traffic is not so busy.",
"Please download a new version from http://www.AndreasKrueger.de/euro/download",
"A bug. Please contact the author.", "",
"Your datafile is probably write-protected. Remove that.",
"", "", "", "", "", "", "", "Very strange - please tell the author!",
"Try again tomorrow (best), contact the author (good) or delete your datafile (not so good)",
"No working Internet connection on your side. Fix it . OR: No server running. Nothing you can do now. Please try again later. ",
"", "", "Not a problem at all. Your data has been uploaded successfully!",
"Probably best idea to get a newer programversion or describe the problem to the author.",
"Please try again later or contact the author.",
"It is important that you notify the author of his server malfunction!",
"It is important that you notify the author of his server malfunction!",
"Your client doesn't understand the server anymore. New version from www.AndreasKrueger.de/euro/download !",
"","","","","","","","","",""};

const QString ABOUTTEXT=
     "CYE is a research project that needs you!\n"
	 "The diffusion of the national Euro-coins can be studied,\n"
	 "if enough nice people all over Europe spend 1-2 minutes per week\n"
	 "or month with feeding their purses into this program.\n\n"
	 "All the data is sent to a server over the Internet, then analyzed\n"
	 "and the analysis is published again as soon as possible.\n\n"
	 "! Please only input coins from your actual daily purse not from your coin collection!\n"
	 "! Soon I will program a version for coin collectors, but for now please only input 'free floating coins'!\n\n"
     "Client-Version %1 (%2)\nCopyright 2002 Andreas Krueger\n"
     "License: The program should be copied as often as possible.\n\n"
     "For technical support, sponsor offers or news alerts,\n"
	 "see  www.AndreasKrueger.de/euro\n";

const QString ERRORSAVING=
	"Problems with saving the data (error %1)"
	"\nProbably the data file '%2' "
	"is read-only (e.g. it's on a CD)."
	"\n\nSolutions: Copy everything to"
	" your harddisk \nand (or) remove the write-protection from "
	"'%3'.\n\nDo you want to solve the problem "
	"on the harddisk\nand go back to the program?";


#ifdef _MSC_VER
// The debugger can't handle symbols more than 255 characters long.
// STL often creates symbols longer than that.
// When symbols are longer than 255 characters, the warning is disabled.
#pragma warning(disable:4786)
#endif

#include<vector>
using std::vector;

#endif // CONSTANTS_H
